﻿DECLARE @SysCultureMaxIndex INT;
SELECT @SysCultureMaxIndex = MAX([Index])
FROM SysCulture;

IF OBJECT_ID('tempdb.dbo.#SysCultureNew') IS NOT NULL
	DROP TABLE #SysCultureNew;

CREATE TABLE #SysCultureNew
(
	Id UNIQUEIDENTIFIER,
	Name NVARCHAR(250),
	LanguageId UNIQUEIDENTIFIER
);

INSERT INTO #SysCultureNew
	(Id, Name)
VALUES
	(NEWID(), 'es-ES'),
	(NEWID(), 'fr-FR'),
	(NEWID(), 'it-IT'),
	(NEWID(), 'nl-NL'),
	(NEWID(), 'pt-BR'),
	('1A778E3F-0A8E-E111-84A3-00155D054C03', 'ru-RU');

UPDATE #SysCultureNew
SET
	LanguageId = sl.Id
FROM SysLanguage sl
WHERE sl.Code COLLATE Cyrillic_General_CI_AI = #SysCultureNew.Name;

-- cursor is a workaround of TRSysCultureAI trigger bug
DECLARE @Id UNIQUEIDENTIFIER;
DECLARE @Name NVARCHAR(250);
DECLARE @LanguageId UNIQUEIDENTIFIER;
DECLARE @Active BIT = 1;
DECLARE @Index INT = (SELECT MAX([Index]) + 1 FROM [SysCulture]);

DECLARE cur CURSOR LOCAL FOR
	SELECT Id, Name, LanguageId
	FROM #SysCultureNew;

OPEN cur;

FETCH NEXT FROM cur INTO @Id, @Name, @LanguageId;

WHILE @@FETCH_STATUS = 0 BEGIN
	IF NOT EXISTS (SELECT 1 FROM [SysCulture] WHERE [Name] = @Name)
	BEGIN
		INSERT INTO SysCulture
			(Id, Name, Active, [Index], LanguageId)
		VALUES
			(@Id, @Name, @Active, @Index, @LanguageId);
		SET @Index = @Index + 1;    	
    END
	FETCH NEXT FROM cur INTO @Id, @Name, @LanguageId;
END

CLOSE cur;
DEALLOCATE cur;

/* replace cursor for that when TRSysCultureAI trigger bug will be fixed
INSERT INTO SysCulture
	(Name, Active, [Index], LanguageId)
SELECT scn.*
FROM #SysCultureNew scn
LEFT JOIN SysCulture ON SysCulture.Name COLLATE Cyrillic_General_CS_AI = scn.Name
WHERE SysCulture.Id IS NULL;
*/