IF (SELECT TOP (1) 1 FROM SysLic) IS NULL
	RETURN;

DECLARE @ShowInFunnelSQL NVARCHAR(MAX) =
	'UPDATE [OpportunityStage]
	SET [OpportunityStage].[ShowInFunnel] = [OpportunityStage_backup].[ShowInFunnel]
	FROM [OpportunityStage_backup]
	INNER JOIN [OpportunityStage] ON [OpportunityStage_backup].[Id] = [OpportunityStage].[Id]';
DECLARE @ShowInProgressBarSQL NVARCHAR(MAX) =
	'UPDATE [OpportunityStage]
	SET [OpportunityStage].[ShowInProgressBar] = [OpportunityStage_backup].[ShowInProgressBar]
	FROM [OpportunityStage_backup]
	INNER JOIN [OpportunityStage] ON [OpportunityStage_backup].[Id] = [OpportunityStage].[Id]';

IF (OBJECT_ID('OpportunityStage') IS NOT NULL) AND (OBJECT_ID('OpportunityStage_backup') IS NOT NULL)
BEGIN
	UPDATE [OpportunityStage]
	SET [OpportunityStage].[Name] = [OpportunityStage_backup].[Name]
		,[OpportunityStage].[End] = [OpportunityStage_backup].[End]
		,[OpportunityStage].[Successful] = [OpportunityStage_backup].[Successful]
		,[OpportunityStage].[Number] = [OpportunityStage_backup].[Number]
		,[OpportunityStage].[MaxProbability] = [OpportunityStage_backup].[MaxProbability]
	FROM [OpportunityStage_backup]
	INNER JOIN [OpportunityStage] ON [OpportunityStage_backup].[Id] = [OpportunityStage].[Id];

	IF EXISTS (SELECT TOP (1)
				1
			FROM INFORMATION_SCHEMA.COLUMNS
			WHERE TABLE_NAME = 'OpportunityStage'
			AND COLUMN_NAME = 'ShowInFunnel')
		EXEC (@ShowInFunnelSQL);

	IF EXISTS (SELECT TOP (1)
				1
			FROM INFORMATION_SCHEMA.COLUMNS
			WHERE TABLE_NAME = 'OpportunityStage'
			AND COLUMN_NAME = 'ShowInProgressBar')
		EXEC (@ShowInProgressBarSQL);
END

IF (OBJECT_ID('QualifyStatus') IS NOT NULL) AND (OBJECT_ID('QualifyStatus_backup') IS NOT NULL)
	UPDATE [QualifyStatus]
	SET [QualifyStatus].[Name] = [QualifyStatus_backup].[Name]
		,[QualifyStatus].[StageNumber] = [QualifyStatus_backup].[StageNumber]
		,[QualifyStatus].[Color] = [QualifyStatus_backup].[Color]
		,[QualifyStatus].[IsDisplayed] = [QualifyStatus_backup].[IsDisplayed]
		,[QualifyStatus].[StageOrder] = [QualifyStatus_backup].[StageOrder]
		,[QualifyStatus].[StageInnerOrder] = [QualifyStatus_backup].[StageInnerOrder]
		,[QualifyStatus].[IsFinal] = [QualifyStatus_backup].[IsFinal]
	FROM [QualifyStatus_backup]
	INNER JOIN [QualifyStatus] ON [QualifyStatus_backup].[Id] = [QualifyStatus].[Id];

IF (OBJECT_ID('QualifyStatusDecoupling') IS NOT NULL) AND (OBJECT_ID('QualifyStatusDecoupling_backup') IS NOT NULL)
	UPDATE [QualifyStatusDecoupling]
	SET [QualifyStatusDecoupling].[CurrentStatusId] = [QualifyStatusDecoupling_backup].[CurrentStatusId]
		,[QualifyStatusDecoupling].[AvailableStatusId] = [QualifyStatusDecoupling_backup].[AvailableStatusId]
	FROM [QualifyStatusDecoupling_backup]
	INNER JOIN [QualifyStatusDecoupling] ON [QualifyStatusDecoupling_backup].[Id] = [QualifyStatusDecoupling].[Id];

IF (OBJECT_ID('CaseStatus') IS NOT NULL) AND (OBJECT_ID('CaseStatus_backup') IS NOT NULL)
	UPDATE [CaseStatus]
	SET [CaseStatus].[Name] = [CaseStatus_backup].[Name]
		,[CaseStatus].[IsFinal] = [CaseStatus_backup].[IsFinal]
		,[CaseStatus].[IsResolved] = [CaseStatus_backup].[IsResolved]
		,[CaseStatus].[IsPaused] = [CaseStatus_backup].[IsPaused]
		,[CaseStatus].[ButtonCaption] = [CaseStatus_backup].[ButtonCaption]
		,[CaseStatus].[IsCloseOnSave] = [CaseStatus_backup].[IsCloseOnSave]
		,[CaseStatus].[Color] = [CaseStatus_backup].[Color]
		,[CaseStatus].[IsDisplayed] = [CaseStatus_backup].[IsDisplayed]
		,[CaseStatus].[StageNumber] = [CaseStatus_backup].[StageNumber]
	FROM [CaseStatus_backup]
	INNER JOIN [CaseStatus] ON [CaseStatus_backup].[Id] = [CaseStatus].[Id];

IF (OBJECT_ID('Tax') IS NOT NULL) AND (OBJECT_ID('Tax_backup') IS NOT NULL)
	UPDATE [Tax]
	SET [Tax].[Name] = [Tax_backup].[Name]
		,[Tax].[Percent] = [Tax_backup].[Percent]
	FROM [Tax_backup]
	INNER JOIN [Tax] ON [Tax_backup].[Id] = [Tax].[Id];

IF (OBJECT_ID('SatisfactionLevel') IS NOT NULL) AND (OBJECT_ID('SatisfactionLevel_backup') IS NOT NULL)
	UPDATE [SatisfactionLevel]
	SET [SatisfactionLevel].[Name] = [SatisfactionLevel_backup].[Name]
		,[SatisfactionLevel].[Point] = [SatisfactionLevel_backup].[Point]
		,[SatisfactionLevel].[Colour] = [SatisfactionLevel_backup].[Colour]
		,[SatisfactionLevel].[StatusId] = [SatisfactionLevel_backup].[StatusId]
	FROM [SatisfactionLevel_backup]
	INNER JOIN [SatisfactionLevel] ON [SatisfactionLevel_backup].[Id] = [SatisfactionLevel].[Id];

IF (OBJECT_ID('DuplicatesRule') IS NOT NULL) AND (OBJECT_ID('DuplicatesRule_backup') IS NOT NULL)
	UPDATE [DuplicatesRule]
	SET [DuplicatesRule].[IsActive] = [DuplicatesRule_backup].[IsActive]
	FROM [DuplicatesRule_backup]
	INNER JOIN [DuplicatesRule] ON [DuplicatesRule_backup].[Id] = [DuplicatesRule].[Id];

IF (OBJECT_ID('ActivityCategory') IS NOT NULL) AND (OBJECT_ID('ActivityCategory_backup') IS NOT NULL)
	UPDATE [ActivityCategory]
	SET [ActivityCategory].[Name] = [ActivityCategory_backup].[Name]
		,[ActivityCategory].[ActivityTypeId] = [ActivityCategory_backup].[ActivityTypeId]
	FROM [ActivityCategory_backup]
	INNER JOIN [ActivityCategory] ON [ActivityCategory_backup].[Id] = [ActivityCategory].[Id];

IF (OBJECT_ID('CommunicationType') IS NOT NULL) AND (OBJECT_ID('CommunicationType_backup') IS NOT NULL)
	UPDATE [CommunicationType]
	SET [CommunicationType].[UseforContacts] = [CommunicationType_backup].[UseforContacts]
		,[CommunicationType].[UseforAccounts] = [CommunicationType_backup].[UseforAccounts]
	FROM [CommunicationType_backup]
	INNER JOIN [CommunicationType] ON [CommunicationType_backup].[Id] = [CommunicationType].[Id];

IF (OBJECT_ID('OpportunityMood') IS NOT NULL) AND (OBJECT_ID('OpportunityMood_backup') IS NOT NULL)
	UPDATE [OpportunityMood]
	SET [OpportunityMood].[Name] = [OpportunityMood_backup].[Name]
		,[OpportunityMood].[ImageId] = [OpportunityMood_backup].[ImageId]
	FROM [OpportunityMood_backup]
	INNER JOIN [OpportunityMood] ON [OpportunityMood_backup].[Id] = [OpportunityMood].[Id];

IF (OBJECT_ID('OpportunityDepartment') IS NOT NULL) AND (OBJECT_ID('OpportunityDepartment_backup') IS NOT NULL)
	UPDATE [OpportunityDepartment]
	SET [OpportunityDepartment].[Name] = [OpportunityDepartment_backup].[Name]
		,[OpportunityDepartment].[SalesDirectorId] = [OpportunityDepartment_backup].[SalesDirectorId]
	FROM [OpportunityDepartment_backup]
	INNER JOIN [OpportunityDepartment] ON [OpportunityDepartment_backup].[Id] = [OpportunityDepartment].[Id];

IF (OBJECT_ID('EmailTemplate') IS NOT NULL) AND (OBJECT_ID('EmailTemplate_backup') IS NOT NULL)
UPDATE [EmailTemplate]
SET [EmailTemplate].[ProcessListeners] = [EmailTemplate_backup].[ProcessListeners],
	[EmailTemplate].[Name] = [EmailTemplate_backup].[Name],
	[EmailTemplate].[ObjectId] = [EmailTemplate_backup].[ObjectId],
	[EmailTemplate].[Recipient] = [EmailTemplate_backup].[Recipient],
	[EmailTemplate].[CopyRecipient] = [EmailTemplate_backup].[CopyRecipient],
	[EmailTemplate].[BlindCopyRecipient] = [EmailTemplate_backup].[BlindCopyRecipient],
	[EmailTemplate].[Subject] = [EmailTemplate_backup].[Subject],
	[EmailTemplate].[PriorityId] = [EmailTemplate_backup].[PriorityId],
	[EmailTemplate].[Body] = [EmailTemplate_backup].[Body],
	[EmailTemplate].[IsHtmlBody] = [EmailTemplate_backup].[IsHtmlBody],
	[EmailTemplate].[Macros] = [EmailTemplate_backup].[Macros],
	[EmailTemplate].[SendIndividualEmailId] = [EmailTemplate_backup].[SendIndividualEmailId],
	[EmailTemplate].[SaveAsActivity] = [EmailTemplate_backup].[SaveAsActivity],
	[EmailTemplate].[ObjectFieldInActivity] = [EmailTemplate_backup].[ObjectFieldInActivity],
	[EmailTemplate].[ShowBeforeSending] = [EmailTemplate_backup].[ShowBeforeSending],
	[EmailTemplate].[TemplateConfig] = [EmailTemplate_backup].[TemplateConfig]
FROM [EmailTemplate_backup]
	INNER JOIN [EmailTemplate] ON [EmailTemplate_backup].[Id] = [EmailTemplate].[Id];

IF (OBJECT_ID('WSysAccount') IS NOT NULL) AND (OBJECT_ID('WSysAccount_backup') IS NOT NULL)
UPDATE [WSysAccount]
SET [WSysAccount].[ProcessListeners] = [WSysAccount_backup].[ProcessListeners],
	[WSysAccount].[Name] = [WSysAccount_backup].[Name],
	[WSysAccount].[ContactId] = [WSysAccount_backup].[ContactId],
	[WSysAccount].[Login] = [WSysAccount_backup].[Login],
	[WSysAccount].[Password] = [WSysAccount_backup].[Password],
	[WSysAccount].[RoleId] = [WSysAccount_backup].[RoleId]
FROM [WSysAccount_backup]
	INNER JOIN [WSysAccount] ON [WSysAccount_backup].[Id] = [WSysAccount].[Id];

IF (OBJECT_ID('RuleRelation') IS NOT NULL) AND (OBJECT_ID('RuleRelation_backup') IS NOT NULL)
UPDATE [RuleRelation]
SET [RuleRelation].[ProcessListeners] = [RuleRelation_backup].[ProcessListeners],
	[RuleRelation].[Name] = [RuleRelation_backup].[Name],
	[RuleRelation].[Description] = [RuleRelation_backup].[Description],
	[RuleRelation].[EntitySchemaUId] = [RuleRelation_backup].[EntitySchemaUId],
	[RuleRelation].[EntitySchemaColumnUId] = [RuleRelation_backup].[EntitySchemaColumnUId],
	[RuleRelation].[EntitySchemaSearchUId] = [RuleRelation_backup].[EntitySchemaSearchUId],
	[RuleRelation].[EntitySchemaSearchColumnUId] = [RuleRelation_backup].[EntitySchemaSearchColumnUId],
	[RuleRelation].[Rule] = [RuleRelation_backup].[Rule]
FROM [RuleRelation_backup]
	INNER JOIN [RuleRelation]
		ON [RuleRelation_backup].[Id] = [RuleRelation].[Id];