﻿DECLARE @DisableTriggerTemplate NVARCHAR(MAX) = 'DISABLE TRIGGER [@Name] ON [@TableName]';
DECLARE @Cmd NVARCHAR(MAX);
DECLARE @Name SYSNAME;
DECLARE @TableName SYSNAME;

IF OBJECT_ID('DisabledTriggers') IS NOT NULL
	DROP TABLE DisabledTriggers;

CREATE TABLE DisabledTriggers (
	Name SYSNAME,
	TableName SYSNAME
);

INSERT INTO DisabledTriggers (Name, TableName)
	SELECT
		OBJECT_NAME(d.referencing_id) AS Name
	   ,OBJECT_NAME(t.parent_id) AS TableName
	FROM sys.sql_expression_dependencies d
	JOIN sys.triggers t
		ON t.object_id = d.referencing_id
	WHERE referenced_entity_name = 'SysImage'
		AND t.is_disabled = 0;

DECLARE cur CURSOR FAST_FORWARD READ_ONLY LOCAL FOR
	SELECT
		Name,
		TableName
	FROM DisabledTriggers
	ORDER BY TableName;

OPEN cur;

FETCH NEXT FROM cur INTO @Name, @TableName;
WHILE @@FETCH_STATUS = 0 BEGIN
	SET @Cmd = REPLACE(@DisableTriggerTemplate, '@Name', @Name);
	SET @Cmd = REPLACE(@Cmd, '@TableName', @TableName);
	PRINT @Cmd;
	EXEC (@Cmd);
	FETCH NEXT FROM cur INTO @Name, @TableName;
END

CLOSE cur;
DEALLOCATE cur;