﻿DECLARE @EnableTriggerTemplate NVARCHAR(MAX) = 'ENABLE TRIGGER [@Name] ON [@TableName]';
DECLARE @Cmd NVARCHAR(MAX);
DECLARE @Name SYSNAME;
DECLARE @TableName SYSNAME;

IF OBJECT_ID('DisabledTriggers') IS NULL
	RETURN;

DECLARE cur CURSOR FAST_FORWARD READ_ONLY LOCAL FOR
	SELECT
		Name,
		TableName
	FROM DisabledTriggers
	ORDER BY TableName;

OPEN cur;

FETCH NEXT FROM cur INTO @Name, @TableName;
WHILE @@FETCH_STATUS = 0 BEGIN
	SET @Cmd = REPLACE(@EnableTriggerTemplate, '@Name', @Name);
	SET @Cmd = REPLACE(@Cmd, '@TableName', @TableName);
	PRINT @Cmd;
	EXEC (@Cmd);
	FETCH NEXT FROM cur INTO @Name, @TableName;
END

CLOSE cur;
DEALLOCATE cur;

DROP TABLE DisabledTriggers;